<?php

class Eco1 extends CI_Controller {
    function index() {
		//Segments = 1 --> 					   reg, within post data
		//http://www.dbunplugged.com/index.php/reg
		//Segments = 2 --> 					   reg/<id>
		//http://www.dbunplugged.com/index.php/reg/CC_id1	->registration
        
		//$segments = $this->uri->total_segments();
        //echo $segments;
		$this->load->view('eco1_show');
	}
	function table() {
		$this->load->model('model_eco1');
		$this->load->helper(array('form', 'url'));
		$this->load->library('form_validation');
		$this->form_validation->set_error_delimiters('<div class="ui-state-error">', '</div>');
		
		$tempUser = $this->input->post('eco1_user');
		$tempPass = $this->input->post('eco1_pass');
		$tempChoice = $this->input->post('eco1-choice-h-2');
		
		if ($tempChoice == "new") {
			$config = array(
				array( 'field'   => 'eco1_user',  'label' => 'Username', 'rules'   => 'required|xss_clean|alpha_numeric|min_length[5]|max_length[20]|callback_checkuser' ),
				array( 'field'   => 'eco1_pass',  'label' => 'Password', 'rules'   => 'required|xss_clean|alpha_numeric|min_length[5]|max_length[20]' ),
			);
			$this->form_validation->set_rules($config);
			if (($this->form_validation->run())==false) {
				$this->load->view('eco1_show');
			}
			else {
				//add table to database, insert user/pass
				if ($this->model_eco1->eco1_userAdd($tempUser, $tempPass)) {
					log_message('error', 'USER (FAILED):' . $tempUser);
					echo "FAILED to add " . $tempUser;
				}
				else {
					log_message('error', 'USER:' . $tempUser);
					echo "User " . $tempUser . " added.";
					
					$this->load->view('eco1_show');
				}
			}
		}
		else if ($tempChoice == "dump") {
			$config = array(
				array( 'field'   => 'eco1_user',  'label' => 'Username', 'rules'   => 'required|xss_clean|alpha_numeric|min_length[5]|max_length[20]' ),
				array( 'field'   => 'eco1_pass',  'label' => 'Password', 'rules'   => 'required|xss_clean|alpha_numeric|min_length[5]|max_length[20]' ),
			);
			$this->form_validation->set_rules($config);
			if (($this->form_validation->run())==false) {
				$this->load->view('eco1_show');
			}
			else {
				//dump table (database and insert user/pass)
				$query = $this->model_eco1->eco1_userDump($tempUser, $tempPass);
				if (!$query) {
					log_message('error', "DUMP (FAILED):" . $tempUser);
					echo "FAILED to dump " . $tempUser . "\n";
				}
				else {
					log_message('error', "DUMP:" . $tempUser);
					echo "User " . $tempUser . " dumped.\n";
					
					if ($query->num_rows > 0) {
						//var_dump($query->result());
						//print_r($query->result());
						//foreach ($query->result() as $value) {
						//	foreach ($value as $key => $row) {
						//		echo $key . " " . $row . "\n";
						//	}
						//	echo "\n";
						//}
						
						$data['data'] = "<thead><tr>";
						$value = $query->first_row();
						foreach ($value as $key => $row) {
							$data['data'] .= "<th data-priority='1'>" . $key . "</th>";
						}
						$data['data'] .= "</tr></thead><tbody>";
						foreach ($query->result() as $value) {
							$data['data'] .= "<tr>";
							foreach ($value as $key => $row) {
								$data['data'] .= "<td>" . $row . "</td>";
							}
							$data['data'] .= "</tr>";
						}
						$data['data'] .= "</tbody>";
					}
					$this->load->view('eco1_dump', $data);
				}
			}
		}
		else if ($tempChoice == "edit") {
			$config = array(
				array( 'field'   => 'eco1_user',  'label' => 'Username', 'rules'   => 'required|xss_clean|alpha_numeric|min_length[5]|max_length[20]' ),
				array( 'field'   => 'eco1_pass',  'label' => 'Password', 'rules'   => 'required|xss_clean|alpha_numeric|min_length[5]|max_length[20]' ),
			);
			$this->form_validation->set_rules($config);
			if (($this->form_validation->run())==false) {
				$this->load->view('eco1_show');
			}
			else {
				//dump table (database and insert user/pass)
				$query = $this->model_eco1->eco1_userEdit($tempUser, $tempPass);
				if (!$query) {
					log_message('error', "EDIT-DUMP (FAILED):" . $tempUser);
					echo "FAILED to edit-dump " . $tempUser . "\n";
				}
				else {
					log_message('error', "EDIT:" . $tempUser);
					echo "User " . $tempUser . " edited.\n";
					
					$data['data'] = "";
					$data['user'] = $tempUser;
					$data['pass'] = $tempPass;
					if ($query->num_rows > 0) {
						//var_dump($query->result());
						//print_r($query->result());
						//foreach ($query->result() as $value) {
						//	foreach ($value as $key => $row) {
						//		echo $key . " " . $row . "\n";
						//	}
						//	echo "\n";
						//}
						
						$data['data'] .= "<thead><tr>";
						$value = $query->first_row();
						foreach ($value as $key => $row) {
							$data['data'] .= "<th data-priority='1'>" . $key . "</th>";
						}
						$data['data'] .= "</tr></thead><tbody><tr>";
						
						$cntr=0;
						foreach ($value as $key => $row) {
							$data['data'] .= "<td><form name='input' action='" . base_url() . "eco1/table_delColumn' method='post'>
											  <input type='hidden' name='colDelete' id='colDelete' value='" . $key . "'>
											  <input type='hidden' name='eco1_user' id='eco1_user' value='" . $tempUser . "'>
											  <input type='hidden' name='eco1_pass' id='eco1_pass' value='" . $tempPass . "'>
											  <input data-inline='true' type='submit' value='Delete'></form></td>";
						}	 
						$data['data'] .= "</tr></tbody>";
					}
					$this->load->view('eco1_edit', $data);
				}
			}
		}
	}
	function checkuser($str) {
		$this->load->model('model_eco1');
		$query = $this->model_eco1->eco1_userCheck($str);
		if ($query) {
			$this->form_validation->set_message('checkuser', 'The username is already in use');
			return FALSE;
		}
		else {
			return TRUE;
		}
	}
	
	//-----
	
	function table_addColumn() {
		$this->load->helper(array('form', 'url'));
		$this->load->library('form_validation');
		$this->form_validation->set_error_delimiters('<div class="ui-state-error">', '</div>');
		$config = array(
			array( 'field'   => 'eco1_fieldName', 'label' => 'Field Name','rules'   => 'required|xss_clean|alpha_numeric' ),
			array( 'field'   => 'eco1_user',  	  'label' => 'Username',  'rules'   => 'required|xss_clean|alpha_numeric|min_length[5]|max_length[20]' ),
			array( 'field'   => 'eco1_pass',  	  'label' => 'Password',  'rules'   => 'required|xss_clean|alpha_numeric|min_length[5]|max_length[20]' ),
		);
		$this->form_validation->set_rules($config);
		if (($this->form_validation->run())==false) {
			$data["data"] = "";
			$data["user"] = $this->input->post('eco1_user');
			$data["pass"] = $this->input->post('eco1_pass');
			$this->load->view('eco1_edit', $data);
		}
		else {
			$this->load->model('model_eco1');
			$tempChoice = $this->input->post('eco1-add-h-2');
			$this->model_eco1->eco1_table_addColumn($this->input->post('eco1_user'), $this->input->post('eco1_pass'), $this->input->post('eco1_fieldName'), $tempChoice);			
			//echo $this->input->post('eco1_fieldName') . "\n";
			//echo $this->input->post('eco1_user') . "\n";
			//echo $this->input->post('eco1_pass') . "\n";
			
			$this->load->view('eco1_show');
		}
	}
	function table_delColumn() {
		$this->load->model('model_eco1');
		$this->model_eco1->eco1_table_delColumn($this->input->post('eco1_user'), $this->input->post('eco1_pass'), $this->input->post('colDelete'));			
		//echo $this->input->post('colDelete') . "\n";
		//echo $this->input->post('eco1_user') . "\n";
		//echo $this->input->post('eco1_pass') . "\n";
		
		$this->load->view('eco1_show');
	}
	//-----
	
	function put() {
		$segments = $this->uri->total_segments();
        //echo $segments;
		$data = array();
		if ($segments == 1) {
			$user = $this->input->post('user');
			$pass = $this->input->post('pass');
			$items = explode('/', $this->input->post('data'));
			$itemsLen = count($items);
			for ($i=0; $i < $itemsLen; $i+=2) {
				if ($i+1 > $itemsLen)  { echo 2; return 2; } //incorrect number of arguments, must be 1-to-1
				$data[$items[$i]] = $items[$i+1];
			}
		}
		else if ($segments < 5) { echo 1; return 1; } //no elements to add to database
		else {
			$user = urldecode($this->uri->segment(2));
			$pass = urldecode($this->uri->segment(3));
			for ($i=4; $i <= $segments; $i+=2) {
				if ($i+1 > $segments)  { echo 2; return 2; } //incorrect number of arguments, must be 1-to-1
				$key = urldecode($this->uri->segment($i));
				$val = urldecode($this->uri->segment($i+1));
				$data[$key] = $val;
			}
		}
		
		//print_r($data);
		$this->load->model('model_eco1');
		$query = $this->model_eco1->eco1_table_put($user, $pass, $data);
		if (!$query) {echo 3; return 3;}
		//print_r($query);
		
		echo 0;
		return 0;
	}
	function delete() {
		$segments = $this->uri->total_segments();
        //echo $segments;
		$data = array();
		if ($segments == 1) {
			$user = $this->input->post('user');
			$pass = $this->input->post('pass');
			$items = explode('/', $this->input->post('data'));
			$itemsLen = count($items);
			for ($i=0; $i < $itemsLen; $i+=2) {
				if ($i+1 > $itemsLen)  { echo 2; return 2; } //incorrect number of arguments, must be 1-to-1
				$data[$items[$i]] = $items[$i+1];
			}
		}
		else if ($segments < 5) { echo 1; return 1; } //no elements to delete from database
		else {
			$user = urldecode($this->uri->segment(2));
			$pass = urldecode($this->uri->segment(3));
			$data = array();
			for ($i=4; $i <= $segments; $i+=2) {
				if ($i+1 > $segments)  { echo 2; return 2; } //incorrect number of arguments, must be 1-to-1
				$key = urldecode($this->uri->segment($i));
				$val = urldecode($this->uri->segment($i+1));
				$data[$key] = $val;
			}
		}
		
		//print_r($data);
		$this->load->model('model_eco1');
		$query = $this->model_eco1->eco1_table_delete($user, $pass, $data);
		if (!$query) {echo 3; return 3;}
		//print_r($query);
		
		echo 0;
		return 0;
	}
	function get() {
		$segments = $this->uri->total_segments();
		//echo $segments;
		$data = array(
			"limit" => array(),
			"order" => array(),
			"field" => array()
		);
		if ($segments == 1) {
			$user = $this->input->post('user');
			$pass = $this->input->post('pass');
			$items = explode('/', $this->input->post('data'));
			$itemsLen = count($items);
			for ($i=0; $i < $itemsLen; $i) {
				$type = $items[$i++];
				if ($type == "limit") {
					if ($i+1 > $itemsLen)  { echo 2; return 2; } //incorrect number of arguments, must be 1-to-1
					array_push($data["limit"], array($items[$i++] => $items[$i++]));
				}
				else if ($type == "order") {
					if ($i+1 > $itemsLen)  { echo 2; return 2; } //incorrect number of arguments, must be 1-to-1
					array_push($data["order"], array($items[$i++] => $items[$i++]));
				}
				else if ($type == "field") {
					if ($i+1 > $itemsLen)  { echo 2; return 2; } //incorrect number of arguments, must be 1-to-1
					array_push($data["field"], array($items[$i++] => $items[$i++]));
				}
			}
		}
		else if ($segments < 5) { echo 1; return 1; } //no elements to get from database
		else {
			$user = urldecode($this->uri->segment(2));
			$pass = urldecode($this->uri->segment(3));
			for ($i=4; $i <= $segments; $i) {
				$type = urldecode($this->uri->segment($i++));
				if ($type == "limit") {
					if ($i+1 > $segments)  { echo 2; return 2; } //incorrect number of arguments, must be 1-to-1
					array_push($data["limit"], array($this->uri->segment($i++) => $this->uri->segment($i++)));
				}
				else if ($type == "order") {
					if ($i+1 > $segments)  { echo 2; return 2; } //incorrect number of arguments, must be 1-to-1
					array_push($data["order"], array($this->uri->segment($i++) => $this->uri->segment($i++)));
				}
				else if ($type == "field") {
					if ($i+1 > $segments)  { echo 2; return 2; } //incorrect number of arguments, must be 1-to-1
					array_push($data["field"], array($this->uri->segment($i++) => $this->uri->segment($i++)));
				}
			}
		}
		
		//print_r($data);
		//echo "\n\n<br><br>";
		
		//$this->output->enable_profiler(TRUE);
		//$sections = array(
		//	'queries' => TRUE
		//);
		//$this->output->set_profiler_sections($sections);
		
		//print_r($data);
		$this->load->model('model_eco1');
		$query = $this->model_eco1->eco1_table_get($user, $pass, $data);
		if (!$query) {echo 3; return 3;}
		//print_r($query);
		echo json_encode($query);
		//echo 0;
		//return 0;
	}
}